<template>
  <div  class="common insurances" :class="login ? '' : 'gradient-background'">

    <div  class="container mt-100 mb-64">

    <div v-if="login" class="row">
      <div class="col-12">
        <div class="wrapper mt-48 pr-100 pl-100 pt-28 pb-28 ">
          <div class="relative mb-16 search">
            <div class="d-flex justify-content-between align-items-center mb-32">
            <h2 class="">Insurances</h2>
              <button
                @click="uploadModal = true"
                  class="white-btn continue-btn d-flex justify-content-around"
              >
                <span>
                UPLOAD
                  </span>
                <svg width="30" class="ml-4" height="30" viewBox="0 0 24 24" fill="none" xmlns="http://www.w3.org/2000/svg">
                  <path d="M17.9483 14.4441C18.0205 14.8286 18.4346 15.1134 18.7643 14.9027C20.71 13.6594 22 11.4803 22 9C22 5.13401 18.866 2 15 2C12.1108 2 9.63037 3.75042 8.56143 6.24864C8.07015 6.08728 7.54527 6 7 6C4.23858 6 2 8.23858 2 11C2 13.1818 3.3974 15.0371 5.346 15.7199C5.70094 15.8443 6.01654 15.491 6.0022 15.1151C5.97145 14.3095 6.26361 13.4938 6.87868 12.8787L9.87739 9.87997L9.88849 9.86891C10.1738 9.58613 10.5018 9.37237 10.8516 9.22764C11.2054 9.08096 11.5932 9 12 9C12.8216 9 13.5661 9.33029 14.1079 9.86534L14.123 9.88032L17.1213 12.8787C17.5651 13.3224 17.8407 13.8706 17.9483 14.4441Z" fill="#6F767E"/>
                  <path fill-rule="evenodd" clip-rule="evenodd" d="M9.70711 15.7071C9.31658 16.0976 8.68342 16.0976 8.29289 15.7071C7.90237 15.3166 7.90237 14.6834 8.29289 14.2929L11.2929 11.2929C11.4874 11.0984 11.7421 11.0008 11.997 11L12 11L12.003 11C12.1375 11.0004 12.2657 11.0273 12.3828 11.0759C12.5007 11.1247 12.6112 11.197 12.7071 11.2929L15.7071 14.2929C16.0976 14.6834 16.0976 15.3166 15.7071 15.7071C15.3166 16.0976 14.6834 16.0976 14.2929 15.7071L13 14.4142V20C13 20.5523 12.5523 21 12 21C11.4477 21 11 20.5523 11 20V14.4142L9.70711 15.7071Z" fill="#6F767E"/>
                </svg>
              </button>
            </div>
            <div>
            <svg class="search-icon" width="24" height="24" viewBox="0 0 24 24" fill="none" xmlns="http://www.w3.org/2000/svg">
              <path fill-rule="evenodd" clip-rule="evenodd" d="M18 11C18 14.866 14.866 18 11 18C7.13401 18 4 14.866 4 11C4 7.13401 7.13401 4 11 4C14.866 4 18 7.13401 18 11ZM18.0319 16.6177C19.2635 15.078 20 13.125 20 11C20 6.02944 15.9706 2 11 2C6.02944 2 2 6.02944 2 11C2 15.9706 6.02944 20 11 20C13.125 20 15.078 19.2635 16.6177 18.0319L19.2929 20.7071C19.6834 21.0976 20.3166 21.0976 20.7071 20.7071C21.0976 20.3166 21.0976 19.6834 20.7071 19.2929L18.0319 16.6177Z" fill="#fff"/>
            </svg>
            <el-input
              placeholder="Search"
              v-model="search"
            >
            </el-input>
            </div>
          </div>
          <div v-for="(item, index) in insurances.results" class="the-list mb-12" :key="index">
            <a :href="item.file_url" class="d-flex align-items-center justify-content-between" download="" >
              <div>
              <h6>{{item.name}}</h6>
              <p :style="item.is_expired ? 'color: red;': ''">{{item.date}}</p>
              </div>
              <div>
              <svg width="48" height="48" viewBox="0 0 24 24" fill="none" xmlns="http://www.w3.org/2000/svg">
                <path d="M16.7412 15.5564C16.8787 15.6546 17.0525 15.6964 17.2128 15.6431C19.9944 14.717 22 12.0927 22 9C22 5.13401 18.866 2 15 2C12.1108 2 9.63037 3.75042 8.56143 6.24864C8.07015 6.08728 7.54527 6 7 6C4.23858 6 2 8.23858 2 11C2 13.6038 3.99035 15.7428 6.53263 15.9784C6.68166 15.9923 6.8249 15.9284 6.9336 15.8255C7.36665 15.4156 7.91656 15.1421 8.50236 15.0423C8.77458 14.9958 9 14.7761 9 14.5V13C9 11.3431 10.3431 10 12 10C13.6569 10 15 11.3431 15 13V14.5C15 14.7761 15.2254 14.9958 15.4977 15.0413C15.9372 15.1149 16.3635 15.2866 16.7412 15.5564Z" fill="#6F767E"/>
                <path fill-rule="evenodd" clip-rule="evenodd" d="M9.70711 17.2929C9.31658 16.9024 8.68342 16.9024 8.29289 17.2929C7.90237 17.6834 7.90237 18.3166 8.29289 18.7071L11.2929 21.7071C11.4874 21.9016 11.7421 21.9992 11.997 22C11.998 22 11.999 22 12 22C12.001 22 12.002 22 12.003 22C12.1375 21.9996 12.2657 21.9727 12.3828 21.9241C12.5007 21.8753 12.6112 21.803 12.7071 21.7071L15.7071 18.7071C16.0976 18.3166 16.0976 17.6834 15.7071 17.2929C15.3166 16.9024 14.6834 16.9024 14.2929 17.2929L13 18.5858V13C13 12.4477 12.5523 12 12 12C11.4477 12 11 12.4477 11 13V18.5858L9.70711 17.2929Z" fill="#6F767E"/>
              </svg>
                </div>
            </a>
          </div>
          <b-modal class="uploadModal" size="sm" v-model="uploadModal">
            <div class="card p-20">
              <div v-if="step === 2">
                <h3 class="text-center">
                  Uploaded Successfully
                </h3>
              </div>
              <div v-if="step === 1">
              <div v-if="loading" class="loading-spinner">
              <loading-spinner/>
              </div>
              <h3 class="mb-36">Upload Company Insurance</h3>
              <div class="d-flex align-items-center justify-content-between">
                <div class="input-company-name">
                <h4 class="mb-8">Company name</h4>
                <el-input
                    placeholder="Company name"
                    v-model="upload.name"
                    :class="{
                    'hasError': $v.upload.name.$anyError,
                  }"
                >

                </el-input>
                </div>
                <div class="input-date">
                  <h4 class="mb-8">Date</h4>
                <el-date-picker
                    style="width: 100%"
                    v-model="upload.date"
                    format="yyyy/MM/dd"
                    value-format="yyyy-MM-dd"
                    placeholder="Expiry date"
                    :class="{
                    'hasError': $v.upload.date.$anyError,
                  }"
                >
                </el-date-picker>
                </div>
              </div>
              <div class="d-flex align-items-center justify-content-center mt-48">
                <input type="file" class="custom-file-input" @change="previewFiles">

              </div>
                <p class="mt-8">
                  {{fileName}}
                </p>
              <div class="d-flex flex-column align-items-center justify-content-center mt-48">
                <button @click="submit" class="white-btn submit">
                  SUBMIT
                </button>
                <p :class="loginError ? 'animated shake' : ''" v-if="companyNameError" class="mt-36" style="font-size: 16px; color: red">
                  A company with that name already exists!
                </p>
              </div>
              </div>
            </div>
          </b-modal>
      </div>
    </div>
      <div class="col-12 flex">
<!--        <b-pagination-->
<!--            v-model="currentPage"-->
<!--            :total-rows="insurances.total"-->
<!--            :per-page="insurances.page_size"-->
<!--        ></b-pagination>-->
      </div>
    </div>
    <div v-else class="row align-items-center flex-column  mt-100 pt-100 login">
        <div class="relative mb-24">
          <svg width="24" height="24" viewBox="0 0 24 24" fill="none" xmlns="http://www.w3.org/2000/svg">
            <path d="M18 2C19.6569 2 21 3.34315 21 5V19C21 20.6569 19.6569 22 18 22H12C10.3431 22 9 20.6569 9 19V13H13.0858L11.2929 14.7929C10.9024 15.1834 10.9024 15.8166 11.2929 16.2071C11.6834 16.5976 12.3166 16.5976 12.7071 16.2071L15.5 13.4142C16.2811 12.6332 16.281 11.3668 15.5 10.5858L12.7071 7.79289C12.3166 7.40237 11.6834 7.40237 11.2929 7.79289C10.9024 8.18342 10.9024 8.81658 11.2929 9.20711L13.0858 11H9V5C9 3.34315 10.3431 2 12 2H18Z" fill="#6F767E"/>
            <path d="M9 11V13H4C3.44772 13 3 12.5523 3 12C3 11.4477 3.44772 11 4 11H9Z" fill="#6F767E"/>
          </svg>
          <el-input
              :class="{
                    'hasError': $v.verification.login.$anyError,
                  }"
          placeholder="Login"
          v-model="verification.login"
      >
      </el-input>
        </div>
        <div class="relative">
          <svg width="24" height="24" viewBox="0 0 24 24" fill="none" xmlns="http://www.w3.org/2000/svg">
            <path fill-rule="evenodd" clip-rule="evenodd" d="M16 18C19.3137 18 22 15.3137 22 12C22 8.68629 19.3137 6 16 6C13.7792 6 11.8401 7.2066 10.8027 9H5.413C5.14771 9 4.89329 9.10542 4.70574 9.29305L2.7068 11.2929C2.31642 11.6834 2.31649 12.3165 2.70696 12.7069L4.70717 14.7071C4.8947 14.8946 5.14906 15 5.41427 15H10.8027C11.8401 16.7934 13.7792 18 16 18ZM18 12C18 13.1046 17.1046 14 16 14C14.8954 14 14 13.1046 14 12C14 10.8954 14.8954 10 16 10C17.1046 10 18 10.8954 18 12Z" fill="#6F767E"/>
          </svg>

      <el-input
          :class="{
                    'hasError': $v.verification.password.$anyError,
                  }"
          type="password"
          placeholder="Password"
          v-model="verification.password"
      >
      </el-input>

      </div>
      <button @click="checkLogin()" class="white-btn submit mt-36">
        Log in
      </button>

      <p  v-if="loginError" :class="loginError ? 'animated shake' : ''" class="mt-36" style="color: red">
        Login or Password is incorrect
      </p>
      </div>
    </div>

  </div>
</template>

<script>
import {mapState} from "vuex";
import {required} from "vuelidate/lib/validators";

export default {
  name: "index",
  layout: "pages",
  data(){
    return{
      currentDate: '',
      currentPage: 1,
      step: 1,
      loading: false,
      login: false,
      companyNameError: false,
      search: "",
      uploadModal: false,
      fileName: '',
      loginError: '',
      upload: {
        name: '',
        date: '',
        file: undefined
      },
      verification: {
        password: '',
        login: ''
      }
    }
  },
  async fetch() {
    await this.$store.dispatch("fetchInsurances", this.search);
  },
  watch: {
   async search() {
     this.$fetch()
      },
    },
  computed: {
    ...mapState({
      insurances: (state) => state.insurances,
    }),
  },
  validations: {
    upload: {
      name: {required},
      date: {required},
      file: {required}
    },
    verification: {
      login: {required},
      password: {required}
    }
  },
  methods: {
    previewFiles(event) {
      this.upload.file = event.target.files
      this.fileName = event.target.files[0].name
    },
    submit() {
      this.$v.upload.$touch();
        if (!this.$v.upload.$invalid) {
           this.$axios.post('/documents/validate/', {
            name: this.upload.name
          })
              .then(response => {
                  this.loading = true
                  let formData = new FormData();
                  this.upload.name && formData.append('name', this.upload.name);
                  this.upload.date && formData.append('date', this.upload.date);
                  this.upload.file && formData.append('file', this.upload.file[0]);
                  this.$axios.post('/documents/create/', formData)
                      .then(response => {
                      })
                      .finally(() => {
                        this.loading = false
                        this.step = 2
                        setTimeout(() => {
                          this.uploadModal = false
                          this.step = 1
                        })
                      });
              })
              .catch(error =>{
                this.companyNameError = true
              })

          }
    },
    checkLogin() {
      this.$v.verification.$touch();
      if (!this.$v.verification.$invalid) {
        let login = 'usstartrucking@gmail.com'
        let password = 'Useruss123'
        if (this.verification.login === login && this.verification.password === password) {
          this.login = true
        } else {
          this.loginError = true
        }
      }
    }
  },
  mounted() {
    let today = new Date();
    let dd = String(today.getDate()).padStart(2, '0');
    let mm = String(today.getMonth() + 1).padStart(2, '0'); //January is 0!
    let yyyy = today.getFullYear();

    today = mm + '/' + dd + '/' + yyyy;
    this.currentDate = today
  }

}
</script>

<style>


</style>
